;***************************************************************************
;* Const Def



;***************************************************************************
;**** VARIABLES
.DSEG



;***************************************************************************
;****		C O D E S
;****
;***************************************************************************
.CSEG

EXT_INT0:		RETI		; IRQ0 Handler
EXT_INT1:		RETI		; IRQ1 Handler
EXT_INT2:		RETI		; IRQ2 Handler
EXT_INT3:		RETI		; IRQ3 Handler
;EXT_INT4:		RETI		; IRQ4 Handler
;EXT_INT5:		RETI		; IRQ5 Handler
;EXT_INT6:		RETI		; IRQ6 Handler
EXT_INT7:		RETI		; IRQ7 Handler
TIM2_COMP:		RETI		; Timer2 Compare Handler
TIM2_OVF:		RETI		; Timer2 Overflow Handler
TIM1_CAPT:		RETI		; Timer1 Capture Handler
TIM1_COMPA:		RETI		; Timer1 CompareA Handler
TIM1_COMPB:		RETI		; Timer1 CompareB Handler
TIM1_OVF:		RETI		; Timer1 Overflow Handler
TIM0_COMP:		RETI		; Timer0 Compare Handler
TIM0_OVF:		RETI		; Timer0 Overflow Handler
SPI_STC:		RETI		; SPI Transfer Complete Handler
;USART0_RXC:		RETI		; USART0 RX Complete Handler
;USART0_DRE:		RETI		; USART0,UDR Empty Handler
;USART0_TXC:		RETI		; USART0 TX Complete Handler
;ADC:			RETI		; ADC Conversion Complete Handler
EE_RDY:			RETI		; EEPROM Ready Handler
ANA_COMP:		RETI		; Analog Comparator Handler
TIM1_COMPC:		RETI		; Timer1 CompareC Handler
TIM3_CAPT:		RETI		; Timer3 Capture Handler

;****************************************
;* HW Timer3 CompareA
;*
TIM3_COMPA:					; Timer3 CompareA Handler
		PUSH	ZL
		PUSH	ZH
		IN	ZL,SREG
		PUSH	ZL

		lds	ZL,SCNT1+0		;Software Timer1
		lds	ZH,SCNT1+1
		OR	ZL,ZH
		BREQ	TIM3CA_00
		lds	ZL,SCNT1+0
		SBIW	ZL,1
		sts	SCNT1+0,ZL
		sts	SCNT1+1,ZH

TIM3CA_00:     	lds	ZL,SCNT2+0 		;Software Timer2
		lds	ZH,SCNT2+1
		OR	ZL,ZH
		BREQ	TIM3CA_01
		lds	ZL,SCNT2+0
		SBIW	ZL,1
		sts	SCNT2+0,ZL
		sts	SCNT2+1,ZH



TIM3CA_01:     	lds	ZL,SCNT3+0 		;Software Timer3, BEEP
		lds	ZH,SCNT3+1
		OR	ZL,ZH
		BREQ	TIM3CA_02
		lds	ZL,SCNT3+0
		SBIW	ZL,1
		sts	SCNT3+0,ZL
		sts	SCNT3+1,ZH
		brne	TIM3CA_02		;ha nem 0, akkor Speaker meg szolhat
		ldi	ZL,0b00001000		;ICNC1 ICES1 - WGM13 WGM12 CS12 CS11 CS10
		out	TCCR1B,ZL		;Timer1 Stop!!
		SBI	LED0_PORT,LED0		;Red LED off

		

TIM3CA_02:
	     	lds	ZL,SCNT4+0 		;Software Timer4
		lds	ZH,SCNT4+1
		OR	ZL,ZH
		BREQ	TIM3CA_03
		lds	ZL,SCNT4+0
		SBIW	ZL,1
		sts	SCNT4+0,ZL
		sts	SCNT4+1,ZH

TIM3CA_03:
		lds	ZL,SWTmr0		;8 bites SW Timer
		tst	ZL
		breq	TIM3CA_04
		dec	ZL
		sts	SWTmr0,ZL

TIM3CA_04:

		call	StartADC	

		POP	ZL
		OUT	SREG,ZL
		POP	ZH
		POP	ZL
		RETI



			RETI
TIM3_COMPB:		RETI		; Timer3 CompareB Handler
TIM3_COMPC:		RETI		; Timer3 CompareC Handler
TIM3_OVF:		RETI		; Timer3 Overflow Handler
;USART1_RXC:		RETI		; USART1 RX Complete Handler
;USART1_DRE:		RETI		; USART1,UDR Empty Handler
;USART1_TXC:		RETI		; USART1 TX Complete Handler
;TWI:			RETI		; Two-wire Serial Interface Interrupt Handler
SPM_RDY:		RETI		; SPM Ready Handler

